<script setup lang="ts">
import { storeToRefs } from 'pinia'
import _ from 'lodash'
import { C } from 'chart.js/dist/chunks/helpers.core'
import { useChatStore } from '~/store/chat'
import { useAccountStore } from '~~/store/account'
import { useCallStore } from '~~/store/call'

// set up Chat and scroll to bottom when new message
const chat = useChatStore()
const {
  data: dataMessage,
  pinnedChat,
} = storeToRefs(chat)
const call = useCallStore()
const { currentCall } = storeToRefs(call)

const parent = ref<HTMLElement | null>(null)
const child = ref<HTMLElement | null>(null)

const account = useAccountStore()
const {
  id: uuid,
  full,
} = storeToRefs(account)

const scrollBottom = () => {
  setTimeout(() => {
    if (parent.value)
      parent.value.scrollTop = parent.value.scrollHeight
  })
}

const { height: pHeight } = useElementSize(parent)
const { height: cHeight } = useElementSize(child)

watch(
  () => _.size(chat.data),
  scrollBottom,
)
onMounted(() => {
  scrollBottom()
})

const notifyEvent = inject('notifyEvent') as any[]
watch(
  () => _.size(chat.data),
  (value, oldValue) => {
    notifyEvent.push({
      tab: 'comment',
      value: value - oldValue,
    })
  },
)

const { y, height } = useElementBounding(parent)
const message = ref()
const update = () => {
  _.forEach(message.value, mes => mes.update(y.value + height.value))
}
</script>

<template>
  <div v-if="_.size(chat.data)" class="flex-1 relative flex flex-col">
    <div class="px-2 pt-2 z-10 relative flex flex-row">
      <MMessage
        v-if="pinnedChat"
        :id="pinnedChat.id"
        :message="pinnedChat.message"
        :sender="pinnedChat.user.name"
        :self="false"
        :able-to-delete="false"
        :time-stamp="pinnedChat.timeStamp"
        :pinned="true"
      />
      <div v-if="pHeight <= cHeight + 50" class="w-3.5" />
    </div>
    <div class="flex-1 relative">
      <div
        ref="parent"
        class="absolute top-0 left-0 w-full h-full overflow-auto scrollBar flex flex-col"
        :onscroll="update"
      >
        <div
          ref="child"
          class="w-full px-2 py-5 gap-2 flex flex-col"
        >
          <MMessage
            v-for="mess in dataMessage"
            :id="mess.id"
            ref="message"
            :key="mess.id"
            :message="mess.message"
            :sender="mess.user.name"
            :self="uuid === mess.user.id"
            :able-to-delete="account.joinCode === 1"
            :time-stamp="mess.timeStamp"
          />
        </div>
      </div>
    </div>
    <div
      class="bg-gray-200 text-center px-5 flex flex-row justify-center items-center dark:bg-gray-700"
    >
      リハーサル中にコメントした内容は、学生にも表示されてしまうのでご注意ください。<br>
      不要なコメントは、配信開始15分までに削除ください。
    </div>
    <div v-if="full" class="h-1px w-full bg-white op-50" />
  </div>
  <div v-else class="flex-1 px-5 flex items-center justify-center text-center">
    <p>
      リハーサル中にコメントした内容は、学生にも表示されてしまうのでご注意ください。<br>
      不要なコメントは、配信開始15分までに削除ください。
    </p>
  </div>
</template>

<style scoped></style>
